Loading...
Searching...
No Matches
Sip_contact

## Data Structures

struct | sip_contact_s
| Structure for Contact header field. More...

## Macros

#define | sip_contact(sip)
| Access a SIP Contact header structure sip_contact_t from sip_t.
#define | SIP_CONTACT_INIT()
| Initializer for structure sip_contact_t.
#define | SIPTAG_CONTACT(x)
| Tag list item for pointer to a Contact header structure sip_contact_t.
#define | SIPTAG_CONTACT_REF(x)
| Tag list item for reference to a Contact header pointer.
#define | SIPTAG_CONTACT_STR(s)
| Tag list item for string with Contact header value.
#define | SIPTAG_CONTACT_STR_REF(x)
| Tag list item for reference to a Contact header string.

## Typedefs

typedef struct sip_contact_s | sip_contact_t
| @

## Functions

issize_t | sip_contact_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Contact header.
issize_t | sip_contact_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Contact header.
sip_contact_t * | sip_contact_init (sip_contact_t x[1])
| Initialize a structure sip_contact_t.
int | sip_is_contact (sip_header_t const *header)
| Test if header object is instance of sip_contact_t.
sip_contact_t * | sip_contact_dup (su_home_t *home, sip_contact_t const *hdr))
| Duplicate a list of Contact header header structures sip_contact_t.
sip_contact_t * | sip_contact_copy (su_home_t *home, sip_contact_t const *hdr))
| Copy a list of Contact header header structures sip_contact_t.
sip_contact_t * | sip_contact_make (su_home_t *home, char const *s))
| Make a Contact header structure sip_contact_t.
sip_contact_t * | sip_contact_format (su_home_t *home, char const *fmt,...)))
| Make a Contact header from formatting result.
int | sip_contact_add_param (su_home_t *home, sip_contact_t *m, char const *param)
| Add a parameter to a Contact header object.
sip_contact_t * | sip_contact_create (su_home_t *home, url_string_t const *url, char const *p,...)
| Create a contact header.

## Variables

msg_hclass_t | sip_contact_class []
| Header class for Contact header.
tag_typedef_t | siptag_contact
| Tag for Contact header object.
tag_typedef_t | siptag_contact_str
| Tag for string with Contact header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CONTACT_INIT

#define SIP_CONTACT_INIT | ( |  | ) |

Initializer for structure sip_contact_t.

A static sip_contact_t structure for Contact header must be initialized with the SIP_CONTACT_INIT() macro. For instance,

sip_contact_t sip_contact = SIP_CONTACT_INIT;
SIP_CONTACT_INIT
#define SIP_CONTACT_INIT()
Initializer for structure sip_contact_t.
Definition sip_protos.h:2766
sip_contact_t
struct sip_contact_s sip_contact_t
@
Definition sip.h:147
sip_contact
#define sip_contact(sip)
Access a SIP Contact header structure sip_contact_t from sip_t.
Definition sip_protos.h:2749

## SIPTAG_CONTACT

#define SIPTAG_CONTACT | ( |  | x | ) |

Tag list item for pointer to a Contact header structure sip_contact_t.

The SIPTAG_CONTACT() macro is used to include a tag item with a pointer to a sip_contact_t structure in a tag list.

Parameters

  x | pointer to a sip_contact_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CONTACT_REF().

## SIPTAG_CONTACT_STR

#define SIPTAG_CONTACT_STR | ( |  | s | ) |

Tag list item for string with Contact header value.

The SIPTAG_CONTACT_STR() macro is used to include a tag item with a string containing value of a sip_contact_t header in a tag list.

Parameters

  s | pointer to a string containing Contact header value, or NULL.

The string in SIPTAG_CONTACT_STR() can be converted to a sip_contact_t header structure by giving the string s has second argument to function sip_contact_make().

The corresponding tag taking reference parameter is SIPTAG_CONTACT_STR_REF().

## Typedef Documentation

## sip_contact_t

typedef struct sip_contact_s sip_contact_t

@

The Contact header contain a list of URLs used to redirect future requests. Its syntax is defined in RFC 3261 as follows:

Contact = ("Contact" / "m" ) HCOLON
( STAR / (contact-param *(COMMA contact-param)))
contact-param = (name-addr / addr-spec) *(SEMI contact-params)
name-addr = [ display-name ] LAQUOT addr-spec RAQUOT
addr-spec = SIP-URI / SIPS-URI / absoluteURI
display-name = *(token LWS)/ quoted-string
contact-params = c-p-q / c-p-expires
/ contact-extension
c-p-q = "q" EQUAL qvalue
c-p-expires = "expires" EQUAL delta-seconds
contact-extension = generic-param
delta-seconds = 1*DIGIT
DIGIT
#define DIGIT
LWS
#define LWS

Note
  The RFC 2543 syntax allowed <comment>. We accept it, but don't encode it.

Each parsed Contact header field is stored in sip_contact_t structure.

The structure sip_contact_t contains representation of SIP Contact header.

The sip_contact_t is defined as follows:

typedef struct sip_contact_s {
sip_common_t m_common[1]; // Common fragment info
sip_contact_t *m_next; // Link to next
char const *m_display; // Display name
url_t m_url[1]; // SIP URL
msg_param_t const *m_params; // List of contact-params
char const *m_comment; // Comment
char const *m_q; // Priority
char const *m_expires; // Expiration time
} sip_contact_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_contact_s
Structure for Contact header field.
Definition sip.h:473
sip_contact_s::m_next
sip_contact_t * m_next
Link to next Contact header.
Definition sip.h:475
sip_contact_s::m_expires
char const * m_expires
Expiration time.
Definition sip.h:482
sip_contact_s::m_q
char const * m_q
Priority
Definition sip.h:481
sip_contact_s::m_display
char const * m_display
Display name.
Definition sip.h:476
sip_contact_s::m_params
msg_param_t const * m_params
List of contact-params.
Definition sip.h:478
sip_contact_s::m_comment
char const * m_comment
Comment.
Definition sip.h:479
sip_contact_s::m_url
url_t m_url[1]
SIP URL.
Definition sip.h:477
sip_contact_s::m_common
sip_common_t m_common[1]
Common fragment info.
Definition sip.h:474
url_t

Note
  The <comment> field m_comment is deprecated: it is parsed but not included in encoding.

## Function Documentation

## sip_contact_add_param()

int sip_contact_add_param | ( | su_home_t * | home,
|  | sip_contact_t * | m,
|  | char const * | param )

Add a parameter to a Contact header object.

Add a parameter to a Contact object. It does not copy the contents of the string `param`.

Note
  This function does not duplicate `param`.

Parameters

  home | memory home
  m | sip_contact_t object
  param | parameter string

Returns
  0 when successful, and -1 upon an error.

Deprecated
  Use msg_header_replace_param() directly.

## sip_contact_copy()

sip_contact_t * sip_contact_copy | ( | su_home_t * | home,
|  | sip_contact_t const * | hdr )

inline

Copy a list of Contact header header structures sip_contact_t.

The function sip_contact_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  contact = sip_contact_copy(home, sip->sip_contact);
  sip_contact_copy
  sip_contact_t * sip_contact_copy(su_home_t *home, sip_contact_t const *hdr))
  Copy a list of Contact header header structures sip_contact_t.
  Definition sip_protos.h:2896

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_contact_create()

sip_contact_t * sip_contact_create | ( | su_home_t * | home,
|  | url_string_t const * | url,
|  | char const * | p,
|  |  | ... )

Create a contact header.

Create a Contact header object.

Create a Contact header object with the given URL and list of parameters.

Parameters

  home | memory home
  url | URL (string or pointer to url_t)
  p,... | NULL-terminated list of Contact parameters

Returns
  A pointer to newly created Contact header object when successful or NULL upon an error.

## sip_contact_dup()

sip_contact_t * sip_contact_dup | ( | su_home_t * | home,
|  | sip_contact_t const * | hdr )

inline

Duplicate a list of Contact header header structures sip_contact_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  contact = sip_contact_dup(home, sip->sip_contact);
  sip_contact_dup
  sip_contact_t * sip_contact_dup(su_home_t *home, sip_contact_t const *hdr))
  Duplicate a list of Contact header header structures sip_contact_t.
  Definition sip_protos.h:2853

Returns
  A pointer to the newly duplicated sip_contact_t header structure, or NULL upon an error.

## sip_contact_format()

sip_contact_t * sip_contact_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Contact header from formatting result.

Make a new sip_contact_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_contact_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_contact_init()

sip_contact_t * sip_contact_init | ( | sip_contact_t | x[1] | ) |

inline

Initialize a structure sip_contact_t.

An sip_contact_t structure for Contact header can be initialized with the sip_contact_init() function/macro. For instance,

sip_contact_t sip_contact;
sip_contact_init(&sip_contact);
sip_contact_init
sip_contact_t * sip_contact_init(sip_contact_t x[1])
Initialize a structure sip_contact_t.
Definition sip_protos.h:2784

## sip_contact_make()

sip_contact_t * sip_contact_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Contact header structure sip_contact_t.

The function sip_contact_make() makes a new sip_contact_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_contact_t header structure, or NULL upon an error.

## sip_is_contact()

int sip_is_contact | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_contact_t.

Check if the header class is an instance of Contact header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header contact
  0 | (false) otherwise

## Variable Documentation

## sip_contact_class

msg_hclass_t sip_contact_class[]

extern

Header class for Contact header.

The header class sip_contact_class defines how a SIP Contact header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_contact_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.